[BZOJ2238]Mst
[BZOJ2238]Mst
题目大意:
给你一个\(n(n\le50000)\)个点,\(m(m\le10^5)\)条边的无向带权图。\(q(q\le10^5)\)次询问,每次询问去掉一条边后图能否连通,如果连通,求最小生成树。(询问互相独立)
思路:
首先求出最小生成树。对于非树边,去掉这条边对答案没有影响;对于树边,去掉这条边后就把原生成树分成两个不相交的连通块,新的最小生成树就是原树-该边边权+连接两个连通块的最小边。树链剖分+线段树维护即可。
时间复杂度\(\mathcal O((m+q)\log n)\)。
源代码:
#include<cstdio>
#include<cctype>
#include<vector>
#include<climits>
#include<algorithm>
inline int getint() {
register char ch;
while(!isdigit(ch=getchar()));
register int x=ch^'0';
while(isdigit(ch=getchar())) x=(((x<<2)+x)<<1)+(ch^'0');
return x;
}
const int N=5e4+1,M=1e5+1;
int w[M];
struct Edge {
int u,v,id;
bool operator < (const Edge &rhs) const {
return w[id]<w[rhs.id];
}
};
Edge edge[M];
std::vector<int> e[N];
inline void add_edge(const int &u,const int &v) {
e[u].push_back(v);
e[v].push_back(u);
}
class DisjointSet {
private:
int anc[N],cnt;
int find(const int &x) {
return x==anc[x]?x:anc[x]=find(anc[x]);
}
public:
void reset(const int &n) {
cnt=n;
for(register int i=1;i<=n;i++) anc[i]=i;
}
void merge(const int &x,const int &y) {
anc[find(x)]=find(y);
cnt--;
}
bool same(const int &x,const int &y) {
return find(x)==find(y);
}
int size() const {
return cnt;
}
};
DisjointSet djs;
int dep[N],top[N],par[N],son[N],size[N],dfn[N];
void dfs(const int &x,const int &par) {
size[x]=1;
::par[x]=par;
dep[x]=dep[par]+1;
for(unsigned i=0;i<e[x].size();i++) {
const int &y=e[x][i];
if(y==par) continue;
dfs(y,x);
size[x]+=size[y];
if(size[y]>size[son[x]]) {
son[x]=y;
}
}
}
void dfs(const int &x) {
dfn[x]=++dfn[0];
top[x]=x==son[par[x]]?top[par[x]]:x;
if(son[x]!=0) dfs(son[x]);
for(unsigned i=0;i<e[x].size();i++) {
const int &y=e[x][i];
if(y==par[x]||y==son[x]) continue;
dfs(y);
}
}
int pos[M];
class SegmentTree {
#define _left <<1
#define _right <<1|1
#define mid ((b+e)>>1)
private:
int val[N<<2];
public:
void build(const int &p,const int &b,const int &e) {
val[p]=INT_MAX;
if(b==e) return;
build(p _left,b,mid);
build(p _right,mid+1,e);
}
void modify(const int &p,const int &b,const int &e,const int &l,const int &r,const int &v) {
if(l>r||val[p]<=v) return;
if(b==l&&e==r) {
val[p]=std::min(val[p],v);
return;
}
if(l<=mid) modify(p _left,b,mid,l,std::min(mid,r),v);
if(r>mid) modify(p _right,mid+1,e,std::max(mid+1,l),r,v);
}
int query(const int &p,const int &b,const int &e,const int &x) const {
int ret=val[p];
if(b==e) return ret;
if(x<=mid) ret=std::min(ret,query(p _left,b,mid,x));
if(x>mid) ret=std::min(ret,query(p _right,mid+1,e,x));
return ret;
}
#undef _left
#undef _right
#undef mid
};
SegmentTree sgt;
inline int lca(int x,int y) {
while(top[x]!=top[y]) {
if(dep[top[x]]<dep[top[y]]) std::swap(x,y);
x=par[top[x]];
}
if(dep[x]<dep[y]) std::swap(x,y);
return y;
}
inline void modify(int x,int y,const int &w) {
const int z=lca(x,y);
while(top[x]!=top[y]) {
if(dep[top[x]]<dep[top[y]]) std::swap(x,y);
sgt.modify(1,1,dfn[0],dfn[top[x]]+(top[x]==z),dfn[x],w);
x=par[top[x]];
}
if(dep[x]<dep[y]) std::swap(x,y);
sgt.modify(1,1,dfn[0],dfn[y]+(y==z),dfn[x],w);
}
int main() {
const int n=getint(),m=getint();
for(register int i=1;i<=m;i++) {
edge[i].u=getint();
edge[i].v=getint();
w[edge[i].id=i]=getint();
}
std::sort(&edge[1],&edge[m]+1);
int sum=0;
djs.reset(n);
for(register int i=1;i<=m;i++) {
const int &u=edge[i].u,&v=edge[i].v;
if(djs.same(u,v)) continue;
add_edge(u,v);
djs.merge(u,v);
sum+=w[edge[i].id];
}
if(djs.size()!=1) {
for(register int q=getint();q;q--) {
puts("Not connected");
}
return 0;
}
dfs(1,0);
dfs(1);
djs.reset(n);
sgt.build(1,1,n);
for(register int i=1;i<=m;i++) {
int u=edge[i].u,v=edge[i].v;
if(djs.same(u,v)) {
modify(u,v,w[edge[i].id]);
continue;
}
djs.merge(u,v);
if(dep[u]<dep[v]) std::swap(u,v);
pos[edge[i].id]=dfn[u];
}
const int q=getint();
for(register int i=0;i<q;i++) {
const int x=getint();
if(pos[x]==0) {
printf("%d\n",sum);
continue;
}
const int tmp=sgt.query(1,1,n,pos[x]);
if(tmp==INT_MAX) {
puts("Not connected");
continue;
}
printf("%d\n",sum-w[x]+tmp);
}
return 0;
}
[BZOJ2238]Mst的更多相关文章
- [BZOJ2238]Mst 最小生成树+树链剖分/并查集
链接 题解 先构建出最小生成树,如果删的是非树边,直接输出答案 否则问题转化为,把该边删掉后剩下两个联通块,两个端点分别在两个块内的最小边权,LCT可以维护 不妨换一种思考方向:考虑一条非树边可以代替 ...
- BZOJ2238 Mst[最小生成树+树剖+线段树]
跑一遍mst.对于非mst上的边,显然删掉不影响. 如果删边在树上,相当于这时剩下两个连通块.可以证明要重新构成mst只需要再加一条连接两个连通块的最小边,不会证,yy一下,因为原来连通块连的边权和已 ...
- 树剖+线段树||树链剖分||BZOJ2238||Mst
题面:https://www.lydsy.com/JudgeOnline/problem.php?id=2238 思路:先求个最小生成树,然后就对最小生成树上的边做树剖,依次对非树边进行处理,维护非树 ...
- 2019.01.20 bzoj2238: Mst(kruskal+树链剖分)
传送门 树链剖分菜题. 题意简述:给一个无向图,边有边权,每次询问删一条边(对后面的询问无影响)之后的最小生成树. 思路: 先跑一次kruskalkruskalkruskal并把跑出来的最小生成树给链 ...
- Noip前的大抱佛脚----数据结构
目录 数据结构 知识点及其应用 线段树 神奇标记 标记不下放 并查集 维护二分图 维护后继位置 堆 可并堆的可持久化 dsu on tree 方式&原理 适用范围 单调队列 尺取合法区间 模板 ...
- Noip前的大抱佛脚----赛前任务
赛前任务 tags:任务清单 前言 现在xzy太弱了,而且他最近越来越弱了,天天被爆踩,天天被爆踩 题单不会在作业部落发布,所以可(yi)能(ding)会不及时更新 省选前的练习莫名其妙地成为了Noi ...
- NOIP2018 - 一些板子
好多东西都不熟练…… 数论 数论分块「bzoj2956: 模积和」 10.28.2018 #include<bits/stdc++.h> typedef long long ll; ; ; ...
- 【BZOJ2238】Mst 最小生成树+LCA+堆
[BZOJ2238]Mst Description 给出一个N个点M条边的无向带权图,以及Q个询问,每次询问在图中删掉一条边后图的最小生成树.(各询问间独立,每次询问不对之后的询问产生影响,即被删掉的 ...
- 【bzoj2238】Mst(树链剖分+线段树)
2238: Mst Time Limit: 20 Sec Memory Limit: 256 MBSubmit: 465 Solved: 131[Submit][Status][Discuss] ...
随机推荐
- 关于C++中的指针、数组
C++中指针和数组基本等价的原因在于指针算术和C++内部处理数组的方式:将整数变量加一后,其值将增加1:将指针变量加一后,增加的量等于其指向的数据类型的字节数: 指针中存储的是地址,地址在形式上和整数 ...
- C++ 字符串的编码
转载链接:https://www.cnblogs.com/akb48/p/5439154.html windows平台 char 表示单字符,占用一个字节 wchar_t 表示宽字符,占用两个字节 L ...
- php数据库的增删改查
1.查询: 数据的显示,这里就可以嵌入php来进行数据的输出 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 ...
- zabbix通过简单命令监控elasticsearch集群状态
简单命令监控elasticsearch集群状态 原理: 使用curl命令模拟访问任意一个es节点可以反馈的集群状态,集群的状态需要为green curl -sXGET http://serverip: ...
- 安装xcache3.0.3/3.2,为php加速
安装xcache,为php加速 1.安装 # tar xf xcache-3.0.3.tar.bz2 # cd xcache-3.0.3 # /usr/local/php/bin/phpize # ...
- tomcat中gzip压缩
在tomcat中压缩文件,修改server.xml文件中的配置 <Connector port="8080" protocol="HTTP/1.1" co ...
- JS算法之二分查找
二分查找法主要是解决「在一堆有序的数中找出指定的数」这类问题,不管这些数是一维数组还是 多维数组,只要有序,就可以用二分查找来优化. 二分查找是一种「分治」思想的算法,大概流程如下: 1.数组中排在中 ...
- js获取iframe中的元素
var obj=document.getElementById("iframe的name").contentWindow; var ifmObj=obj.document.getE ...
- hdu 2680 多起点一终点
注意这是一个有向图! 多起点,一终点 反过来,看成一个起点,多个终点,找最短路 因为是有向图 所以u->v 要也要反过来成为v->u Sample Input5 8 5 //结点数 边数 ...
- POJ 2377 Bad Cowtractors (Kruskal)
题意:给出一个图,求出其中的最大生成树= =如果无法产生树,输出-1. 思路:将边权降序再Kruskal,再检查一下是否只有一棵树即可,即根节点只有一个 #include <cstdio> ...